InputStreamReader

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.io
Class InputStreamReader

    java.lang.Object
      java.io.Reader
          java.io.InputStreamReader

Direct Known Subclasses:
  FileReader

    public class InputStreamReader

extends Reader

An InputStreamReader is a bridge from byte streams to character streams: It reads bytes and translates them into characters according to a specified character encoding. The encoding that it uses may be specified by name, or the platform's default encoding may be accepted.

Each invocation of one of an InputStreamReader's read() methods may cause one or more bytes to be read from the underlying byte-input stream. To enable the efficient conversion of bytes to characters, more bytes may be read ahead from the underlying stream than are necessary to satisfy the current read operation.

For top efficiency, consider wrapping an InputStreamReader within a BufferedReader. For example:

     BufferedReader in
       = new BufferedReader(new InputStreamReader(System.in));

Since:
  JDK1.1
Version:
  1.25, 00/02/02
Author:
  Mark Reinhold
See Also:
  `BufferedReader`, `InputStream`, Character encodings

Constructor Summary
`InputStreamReader(InputStream in)` Create an InputStreamReader that uses the default character encoding.
`InputStreamReader(InputStream in, String enc)` Create an InputStreamReader that uses the named character encoding.

Method Summary
`void` | `close()` Close the stream.
`String` | `getEncoding()` Returns the canonical name of the character encoding being used by this stream.
`int` | `read()` Read a single character.
`int` | `read(char[] cbuf, int off, int len)` Read characters into a portion of an array.
`boolean` | `ready()` Tell whether this stream is ready to be read.

Methods inherited from class java.io.Reader
`mark, markSupported, read, reset, skip`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### InputStreamReader

    public InputStreamReader(InputStream in)

  Create an InputStreamReader that uses the default character encoding.

  Parameters:
    `in` - An InputStream

### InputStreamReader

    public InputStreamReader(InputStream in,
                             String enc)
                      throws UnsupportedEncodingException

  Create an InputStreamReader that uses the named character encoding.

  Parameters:
    `in` - An InputStream
    `enc` - The name of a supported character encoding
  Throws:
    `UnsupportedEncodingException` - If the named encoding is not supported

Method Detail

### getEncoding

    public String getEncoding()

  Returns the canonical name of the character encoding being used by this stream.

  If this instance was created with the `InputStreamReader(InputStream, String)` constructor then the returned encoding name, being canonical, may differ from the encoding name passed to the constructor. This method may return `null` if the stream has been closed.

  NOTE : In J2ME CDC, there is no concept of historical name, so only canonical name of character encoding is returned.

  Returns:
    a String representing the encoding name, or possibly `null` if the stream has been closed
  See Also:
    Character encodings

### read

    public int read()
             throws IOException

  Read a single character.

  Overrides:
    `read` in class `Reader`
  Returns:
    The character read, or -1 if the end of the stream has been reached
  Throws:
    `IOException` - If an I/O error occurs

### read

    public int read(char[] cbuf,
                    int off,
                    int len)
             throws IOException

  Read characters into a portion of an array.

  Specified by:
    `read` in class `Reader`
  Parameters:
    `cbuf` - Destination buffer
    `off` - Offset at which to start storing characters
    `len` - Maximum number of characters to read
  Returns:
    The number of characters read, or -1 if the end of the stream has been reached
  Throws:
    `IOException` - If an I/O error occurs

### ready

    public boolean ready()
                  throws IOException

  Tell whether this stream is ready to be read. An InputStreamReader is ready if its input buffer is not empty, or if bytes are available to be read from the underlying byte stream.

  Overrides:
    `ready` in class `Reader`
  Returns:
    True if the next read() is guaranteed not to block for input, false otherwise. Note that returning false does not guarantee that the next read will block.
  Throws:
    `IOException` - If an I/O error occurs

### close

    public void close()
               throws IOException

  Close the stream.

  Specified by:
    `close` in class `Reader`
  Throws:
    `IOException` - If an I/O error occurs

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD